<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>40.30</title>

    <title>Users CRUD</title>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
    <!-- Data Table-->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
</head>

<style>
    input {
        background-color: lightgrey;

    }
</style>

<body>
    <div class="container">
        <h1 class="text-center">Danh sách người dùng đăng ký</h1>
        <div class="my-4">
            <button id="add-user-btn" class="btn btn-success">Thêm user</button>
        </div>
        <table id="user-table" class="table table-hover table-striped table-bordered">
            <thead>
                <tr>
                    <th>Id</th>
                    <th>Firstname</th>
                    <th>Lastname</th>
                    <th>Country</th>
                    <th>Subject</th>
                    <th>Customer Type</th>
                    <th>Register Status</th>
                    <th>Action</th>
                </tr>
            </thead>
            <tbody>

            </tbody>
        </table>
    </div>
    <!--Modal-->
    <div id="edit-user-modal" class="modal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Thêm User</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="my-3">
                            <label for="firstname-edit-modal">First Name</label>
                            <input id="firstname-edit-modal" class="form-control">
                        </div>
                        <div class="my-3">
                            <label for="lastname-edit-modal">Last Name</label>
                            <input id="lastname-edit-modal" class="form-control">
                        </div>
                        <div class="my-3">
                            <label for="subject-edit-modal">Subject</label>
                            <input id="subject-edit-modal" class="form-control">
                        </div>
                        <div class="my-3">
                            <label for="country-edit-modal">Country</label>
                            <select id="country-edit-modal" class="form-control">
                                <option value="0">None</option>
                                <option value="VN">Việt Nam</option>
                                <option value="USA">USA</option>
                                <option value="AUS">Australia</option>
                                <option value="CAN">Canada</option>
                            </select>
                        </div>
                        <div class="my-3">
                            <label for="customer-type-edit-modal">Customer Type</label>
                            <select id="customer-type-edit-modal" class="form-control">
                                <option value="0">None</option>
                                <option value="Standard">Standard</option>
                                <option value="Gold">Gold</option>
                                <option value="Premium">Premium</option>
                            </select>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary" id="insert-user-btn">Insert User</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <div id="add-user-modal" class="modal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Sửa User</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <form>
                        <div class="my-3">
                            <label for="firstname-add-modal">First Name</label>
                            <input id="firstname-add-modal" class="form-control">
                        </div>
                        <div class="my-3">
                            <label for="lastname-add-modal">Last Name</label>
                            <input id="lastname-add-modal" class="form-control">
                        </div>
                        <div class="my-3">
                            <label for="subject-add-modal">Subject</label>
                            <input id="subject-add-modal" class="form-control">
                        </div>
                        <div class="my-3">
                            <label for="country-add-modal">Country</label>
                            <select id="country-add-modal" class="form-control">
                                <option value="0">None</option>
                                <option value="VN">Việt Nam</option>
                                <option value="USA">USA</option>
                                <option value="AUS">Australia</option>
                                <option value="CAN">Canada</option>
                            </select>
                        </div>
                        <div class="my-3">
                            <label for="customer-type-add-modal">Customer Type</label>
                            <select id="customer-type-add-modal" class="form-control">
                                <option value="0">None</option>
                                <option value="Standard">Standard</option>
                                <option value="Gold">Gold</option>
                                <option value="Premium">Premium</option>
                            </select>
                        </div>
                        <div class="my-3">
                            <label for="register-status-add-modal">Register Status</label>
                            <select id="register-status-add-modal" class="form-control">
                                <option value="0">None</option>
                                <option value="New">New</option>
                                <option value="Accepted">Accepted</option>
                                <option value="Denied">Denied</option>
                            </select>
                        </div>
                    </form>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-primary" id="update-user-btn">Update User</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>
    <div id="delete-user-modal" class="modal" tabindex="-1" role="dialog">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title">Delete User</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div>This user will be permanently deleted?</div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" id="delete-user-btn">Yes</button>
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                </div>
            </div>
        </div>
    </div>

</body>

<script>
    const gUserId = 0;
    const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
    const gDATA = ['id', 'firstname', 'lastname', 'country', 'subject', 'customerType', 'registerStatus', 'action'];

    const gID_COL = 0;
    const gFIRST_NAME_COL = 1;
    const gLAST_NAME_COL = 2;
    const gCOUNTRY_COL = 3;
    const gSUBJECT_COL = 4;
    const gCUSTOMER_TYPE_COL = 5;
    const gREGISTER_STATUS_COL = 6;
    const gACTION_COL = 7;

    var gListUser = [];

    var gUserTable = $("#user-table").DataTable({
        columns: [
            { data: gDATA[gID_COL] },
            { data: gDATA[gFIRST_NAME_COL] },
            { data: gDATA[gLAST_NAME_COL] },
            { data: gDATA[gCOUNTRY_COL] },
            { data: gDATA[gSUBJECT_COL] },
            { data: gDATA[gCUSTOMER_TYPE_COL] },
            { data: gDATA[gREGISTER_STATUS_COL] },
            { data: gDATA[gACTION_COL] },
        ],
        columnDefs: [
            {
                targets: gACTION_COL,
                defaultContent: `<img class="edit-user" src="https://cdn0.iconfinder.com/data/icons/glyphpack/45/edit-alt-512.png" style="width: 20px;cursor:pointer;">
<img class="delete-user" src="https://cdn4.iconfinder.com/data/icons/complete-common-version-6-4/1024/trash-512.png" style="width: 20px;cursor:pointer;">
`
            }
        ]
    })


    $(document).ready(function () {
        onPageLoading();
        $("#add-user-btn").on('click', function () {
            onAddUserClick();
        })
        //Sửa
        $("#user-table").on("click", ".edit-user", function () {
            onEditUserClick(this);
        })
        $("#user-table").on("click", ".delete-user", function () {
            onDeleteBtnClick(this);
        })
    })

    function onDeleteBtnClick(user) {
        $("#delete-user-modal").modal("show");
        var id = getIdByUser(user);
        $("#delete-user-btn").on("click", function () {
            callApiToDeleteUser(id);
            callApiUser();
            loadDataIntoTable(gListUser);
            $("#delete-user-modal").modal("hide");

        })
    }

    function callApiToDeleteUser(id) {
        $.ajax({
            url: gBASE_URL + id,
            type: 'delete',
            success: function (res) {
                alert("successfully deleted");
            },
            error: function (error) {
                console.log(error);
            }
        })
    }

    function onEditUserClick(user) {
        $("#add-user-modal").modal("show");
        var id = getIdByUser(user);
        //đổ dữ liệu vào bảng modal
        callApiIntoEditModal(id);
        //sửa
        $("#update-user-btn").on("click", function () {
            var vUserNew = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
                customerType: "",
                registerStatus: ""
            }
            readDataEdit(vUserNew);
            var vDuLieuHopLe = validateInpAddAndEdit(vUserNew);
            if (vDuLieuHopLe) {
                callApiToEditUser(vUserNew, id);
                callApiUser();
                loadDataIntoTable(gListUser);
                $("#add-user-modal").modal("hide");
            }
        })
    }


    function callApiToEditUser(user, id) {
        $.ajax({
            url: gBASE_URL + id,
            type: 'PUT',
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(user),
            success: function (res) {
                alert("successfully edited");
            },
            error: function (error) {
                console.log(error);
            }
        })
    }

    function showApiIntoEditModal(user) {
        $("#firstname-add-modal").val(user.firstname);
        $("#lastname-add-modal").val(user.lastname);
        $("#subject-add-modal").val(user.subject);
        $("#country-add-modal option:selected").text(user.country);
        $("#customer-type-add-modal option:selected").text(user.customerType);
        $("#register-status-add-modal option:selected").text(user.registerStatus);
    }

    function callApiIntoEditModal(id) {
        $.ajax({
            url: gBASE_URL + id,
            type: 'get',
            success: function (res) {
                console.log(res);
                showApiIntoEditModal(res);
            },
            error: function (error) {
                console.log(error);
            }
        })
    }

    function readDataEdit(user) {
        user.firstname = $("#firstname-add-modal").val();
        user.lastname = $("#lastname-add-modal").val();
        user.subject = $("#subject-add-modal").val();
        user.country = $("#country-add-modal option:selected").text();
        user.customerType = $("#customer-add-edit-modal option:selected").text();
        user.registerStatus = $("#register-status-add-modal option:selected").text();
        console.log(user);
    }

    function onAddUserClick() {
        $("#edit-user-modal").modal("show");
        $("#insert-user-btn").on("click", function () {
            var vUserNew = {
                firstname: "",
                lastname: "",
                subject: "",
                country: "",
                customerType: ""
            }
            readData(vUserNew);
            var vDuLieuHopLe = validateInpAddAndEdit(vUserNew);
            if (vDuLieuHopLe) {
                callApiToCreateUser(vUserNew);
                callApiUser();
                loadDataIntoTable(gListUser);
                $("#edit-user-modal").modal("hide");
            }
        })
    }

    function callApiToCreateUser(user) {
        $.ajax({
            url: gBASE_URL,
            type: 'post',
            contentType: "application/json;charset=UTF-8",
            data: JSON.stringify(user),
            success: function (res) {
                alert("successfully added");
            },
            error: function (error) {
                console.log(error);
            }
        })
    }

    function validateInpAddAndEdit(user) {
        if (user.firstname == "") {
            alert("[firstname] must fill");
            return false;
        }
        if (user.lastname == "") {
            alert("[lastname] must fill");
            return false;
        }
        if (user.subject == "") {
            alert("[subject] must fill");
            return false;
        }
        if (user.country == "None") {
            alert("[country] must be choosen");
            return false;
        }
        if (user.customerType == "None") {
            alert("[country] must be choosen");
            return false;
        }
        if (user.registerStatus == "None") {
            alert("[RegisterStatus] must be choosen");
            return false;
        }
        return true;
    }

    function readData(user) {
        user.firstname = $("#firstname-edit-modal").val();
        user.lastname = $("#lastname-edit-modal").val();
        user.subject = $("#subject-edit-modal").val();
        user.country = $("#country-edit-modal option:selected").text();
        user.customerType = $("#customer-type-edit-modal option:selected").text();
        console.log(user);
    }

    function onEditBtnClick(paramUser) {
        var vId = getIdByUser(paramUser);
        console.log(vId);
    }

    function onPageLoading() {
        callApiUser();
        loadDataIntoTable(gListUser);
    }

    function loadDataIntoTable(list) {
        gUserTable.clear();
        gUserTable.rows.add(list);
        gUserTable.draw();
    };

    function callApiUser() {
        $.ajax({
            url: gBASE_URL,
            type: 'get',
            async: false,
            success: function (res) {
                console.log(res);
                gListUser = res;
            },
            error: function (error) {
                console.log(error)
            }
        })
    }

    function getIdByUser(paramUser) {
        var vRow = $(paramUser).parents("tr");
        var vData = gUserTable.row(vRow).data();
        return vData.id;
    }
</script>


</html>